#include <cstdio>
#include <cstring>
#include <queue>

using namespace std;

int N, C, maxCnt(0), startx, starty, steps(0);
int map[350][350];
int way[4][2] = {{-1, 0}, {0, -1}, {0, 1}, {1, 0}};
int colors[500];
bool used[350][350];
queue<int>q;

void findStartPoint (int x, int y, int count) {
    used[x][y] = true;

    if (count > maxCnt) {
        maxCnt = count;
        startx = x;
        starty = y;
    }

    for (int i=0; i<4; i++) {
        int newx = x + way[i][0];
        int newy = y + way[i][1];

        if (newx > -1 && newx < N && newy > -1 && newy < N &&
            map[newx][newy] == map[x][y] && !used[newx][newy])
                findStartPoint(newx, newy, count+1);
    }

}

void chooseColor (int x, int y) {
    for (int i=0; i<4; i++) {
        int newx = x+way[i][0], newy = y+way[i][1];
        if (newx > -1 && newx < N && newy > -1 && newy < N && map[newx][newy] != map[x][y] && !used[newx][newy]) {
            colors[map[newx][newy]]++;
            used[newx][newy] = true;
        }
    }

    for (int i=0; i<4; i++) {
        int newx = x+way[i][0], newy = y+way[i][1];
        if (newx > -1 && newx < N && newy > -1 && newy < N && map[newx][newy] == map[x][y] && !used[newx][newy]) {
            used[newx][newy] = true;
            chooseColor (newx, newy);
        }
    }

}

void changeColor(int x, int y, int from, int to) {
    map[x][y] = to;

    for (int i=0; i<4; i++) {
		int newx = x + way[i][0];
        int newy = y + way[i][1];
        if (newx > -1 && newx < N && newy > -1 && newy < N && map[x+way[i][0]][y+way[i][1]] == from)
            changeColor (x+way[i][0], y+way[i][1], from, to);
	}
}

bool solved(int color) {
    for (int i=0; i<N; i++)
        for (int j=0; j<N; j++)
            if (map[i][j] != color) return false;

    return true;
}

void Fill () {
    memset (used, false, sizeof(used));
    memset (colors, 0, sizeof(colors));

    chooseColor (startx, starty);

    int maxC(0);

    for (int i=0; i<C; i++)
        if (colors[i] > maxC) maxC = i;

    q.push(maxC);

    changeColor(startx, starty, map[startx][starty], maxC);
    steps++;

    while (!solved(maxC)) {
        memset (used, false, sizeof(used));
        memset (colors, 0, sizeof(colors));

        chooseColor (startx, starty);

        maxC = 0;

        for (int i=0; i<C; i++)
            if (colors[i] > maxC) maxC = i;

        q.push(maxC);
        changeColor(startx, starty, map[startx][starty], maxC);
        steps++;
    }
}



int main() {
    FILE *fInput, *fOutput;
    fInput = fopen ("flood-it.in","r");
    fOutput = fopen ("flood-it.out", "w");
    fscanf (fInput, "%d%d", &N, &C);

    for (int i=0; i<N; i++)
        for (int j=0; j<N; j++) {
            fscanf (fInput, "%d", &map[i][j]);
            map[i][j]--;
        }

    memset (used, false, sizeof(used));

    for (int i=0; i<N; i++)
        for (int j=0; j<N; j++)
            if (!used[i][j]) findStartPoint (i, j, 1);

    Fill();

    fprintf(fOutput, "%d\n%d %d\n", steps, startx, starty);

    while (!q.empty()){
        fprintf(fOutput, "%d\n", q.front()+1);
        q.pop();

    }
    return 0;
}
